/*==============================================
	DSSound.h
		DirectShowgTEh̍Đ
------------------------------------------------
	ҁFˑ
	F2011/10/17
==============================================*/
#ifndef _INCLUDE_DS_SOUND_H_
#define _INCLUDE_DS_SOUND_H_

#include "../Framework/Framework.h"
#include <dshow.h>
#include <stdio.h>
#pragma comment(lib,"strmiids.lib") 

enum eDSSoundState{
	DS_FADEIN_END	= -2,
	DS_FADEOUT_END	= -3,
	DS_LOOP_SET		= -4,
};

class DSSound{
private:
	
	IGraphBuilder*		m_pGraphBuilder;
	IMediaControl*		m_pMediaControl;		//t@C̓ǂݍ݁AĐ~ȂǂsB
	IMediaPosition*		m_pMediaPosition;	//Đʒuw肷̂ɎgB
	
	bool isPlay;		// Đǂ̃tO
	bool isLoop;		// [v邩ǂ̃tO
	bool isFadeIn;		// tF[hINǂ̃tO
	bool isFadeOut;		// tF[hOUTǂ̃tO
	bool isFadeStop;	// 
	bool isFadePlay;	// 

	int	m_FICount;
	int m_FOCount;
	int m_FSCount;
	int m_FPCount;
	
public:
	// RXgN^
	DSSound();

	// fXgN^
	~DSSound();

	// (t@Cǂݍ)
	int Load(BSTR filePass,bool LoopFlg);
	
	// I
	int DSUninit();

	// Đ
	int Play();

	int PlayForced(bool LoopFlg);

	// ~
	int Stop();

	// ꎞ~
	int Pause();

	// ꎞ~
	int Resume();

	// [v`FbN
	int LoopCheck();

	int VolumMin();
	int VolumMax();
	long VolumNow();
	int SetVolum(long);

	void Release();

	void FadeIn();		// tF[hC(Đ)
	void FadeOut();		// tF[hAEg(Đs)
	void FadeStop();	// tF[hŒ~
	void FadePlay();	// tF[hŊJn

	bool IsPlay(){return isPlay;}	// Đǂn

};



#endif // _INCLUDE_DS_SOUND_H_